!(function(){
    DecCst.factory = {};
    var stepMap = {
        TableDataPreprocessor:{
            type: "preprocessor",
            name: BI.i18nText("Plugin-Dec-Data_Set_Preprocessor")
        },
        TableDataFilter:{
            type: "filter",
            name: BI.i18nText("Plugin-Dec-Data_Set_Filter")
        },
        TableDataFormatter:{
            type: "formatter",
            name: BI.i18nText("Plugin-Dec-Data_Set_Formatter")
        },

    }
    DecCst.factory.step = stepMap;
    advancePane =  BI.inherit(BI.Widget,{

        props: {
            baseCls: "bi-background",
            //height: 24
        },
        _store: function () {

            return BI.Models.getModel("dec.model.factory.widget.advance", {
                list:this.options.info.subConfigs.advanceList,
                info:this.options.info
            });
        },
        beforeInit: function (cb) {
            var self = this;
            Dec.Utils.getDataFactoryGlobalConfig(function(data){
                self.model.globalConfigs = data.data;
                cb();
            })
        },
        getValue: function(){
            var self = this;
            return {
                advanceList:self.options.info.subConfigs.advanceList,
                type: self.checkbox ? self.checkbox.getValue()[0] : 0,
            }
        },
        watch: {
            list:function () {
                this.list.populate(this.model.listItems)
            },


        },
        render: function () {
            var self = this,
                o = this.options;
            var combo
            if(!o.info.globalSetting){
                combo = {
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [
                        {
                            type: "bi.text_value_combo",

                            width: 160,
                            height: 24,
                            value:self.options.info.subConfigs.type,
                            items: [{
                                text:BI.i18nText("Plugin-factory_I_Want_To_Set_Single"),
                                value:0
                            },{
                                text:BI.i18nText("Plugin-factory_Form_Using_Server_Report_View_Settings"),
                                value:1
                            }
                            ],
                            ref: function (ref) {
                                self.checkbox = ref;
                            },
                            listeners: [{
                                eventName:"EVENT_CHANGE",
                                action: function (v){
                                    debugger
                                    if(v === 0){
                                        self.listTable.setVisible(true)
                                    }else{
                                        self.listTable.setVisible(false)
                                    }

                                }
                            }]
                        },{
                            el:{
                                type:"bi.button",
                                width: 80,
                                value: BI.i18nText("Plugin-factory-GlobalSetting"),
                                handler:function(){

                                    var type = "global" + BI.UUID();
                                    var pane = {
                                        type: "dec.factory.basic.popup",
                                        info: {
                                            globalSetting:true,
                                            model:self.options.info.model,
                                            subConfigs:self.model.globalConfigs ? {advanceList:self.model.globalConfigs, type:0} :{advanceList:[], type:0} ,
                                        },
                                        cardType: "dec.factory.widget.advance",
                                        //groupId:o.groupId,
                                        onClickConfirm: function (val, callback) {
                                            Dec.Utils.setDataFactoryGlobalConfig(val.advanceList,function(data){
                                                debugger
                                                callback(true, null)
                                            })
                                            //self.model.subConfigs = val;

                                            //var ids = self.table.getValue();
                                            //self.store.apiTransferGroup(ids, val, callback);
                                        },

                                        listeners: [
                                            {
                                                eventName: "EVENT_CLOSE",
                                                action: function () {

                                                    BI.Popovers.remove(self.getName() + type);
                                                }
                                            }
                                        ]
                                    };
                                    BI.Popovers.create(self.getName() + type, {
                                        type: "bi.popover",
                                        header:  BI.i18nText("Plugin-Factory_Data_Set_Config_Advanced"),
                                        body: pane,
                                        /*   listeners: [
                                               {
                                                   eventName: "EVENT_CLOSE",
                                                   action: function () {
                                                       debugger
                                                       BI.Popovers.remove(self.getName() + type);
                                                   }
                                               }
                                           ]*/
                                    }).open(self.getName() + type);
                                    //self.store.setCacheTime(this.getValue());
                                }
                            },
                            lgap: 256,
                        }
                    ]
                }
                    ;
            }else{
                combo = {
                    type: "bi.label"
                }
            }
            return {
                type: "bi.vertical",
                items: [{
                    el: combo,
                      lgap: 15,
                    rgap: 5

                },{
                    type: "bi.vertical",
                    ref: function (ref) {
                        self.listTable = ref;
                    },
                    invisible:self.options.info.subConfigs.type == 0 ? false :true,
                    items: [{
                        el: {
                            type: "bi.combo",
                            el: {
                                value: "add",
                                height: 36,
                                type: "bi.icon_text_item",
                                text: BI.i18nText("Plugin-Dec-Management_Client_Add"),
                                cls: "text-add-tip-font",
                                logic: {
                                    dynamic: true
                                },
                            },
                            width: 160,

                            popup:{
                                el: {
                                    type:"bi.vertical",
                                    ref: function (ref) {
                                        self.addCheckbox = ref;
                                    },
                                    items: [
                                        self._createAddon("TableDataPreprocessor"),
                                        self._createAddon("TableDataFormatter"),
                                        self._createAddon("TableDataFilter"),

                                    ]
                                }
                            },

                            listeners: [{
                                eventName:"EVENT_CHANGE",
                                action: function (v){

                                }
                            }]
                        },
                        lgap: 15,
                        rgap: 5
                    },{
                        el:{
                            type: "bi.vertical",
                            height : 340,
                            css: {backgroundColor: "#ffffff"},
                            ref: function (ref) {
                                self.list = ref;
                            },
                            hgap: 10,
                            items:self.model.listItems
                        }
                    }]
                }, ]
            };
        },

        _createAddon: function (step){

            var self = this;
            return {
                type:"bi.basic_button",
                height:32,
                cls: "bi-list-item",
                el: {

                    info:{},
                    type:"bi.label",
                    text:stepMap[step].name
                },
                listeners: [{
                    eventName:"BasicButton.EVENT_CHANGE",
                    action: function (){
                        var type = "addoredit" + BI.UUID();
                        var pane = {
                            type: "dec.factory.basic.popup",
                            info: {
                                name:stepMap[step].name,
                                type:self.options.info.model[stepMap[step].type + "Type"],
                                items: self.options.info.model[stepMap[step].type + "Items"],
                                text: self.options.info.model[stepMap[step].type + "Config"],
                            },
                            cardType: "dec.factory.sub.config.editor",
                            //groupId:o.groupId,
                            onClickConfirm: function (val, callback) {
                                if(null != val) {
                                    val.type = step;
                                    self.model.list.push(val);
                                /*    self.options.info.subConfigs.advanceList.push(val);
                                    self.list.addItem({
                                        type:"bi.label",
                                        text: val.customizeName
                                    });*/
                                    //self.options.
                                    callback(true, null)
                                }
                                //var ids = self.table.getValue();
                                //self.store.apiTransferGroup(ids, val, callback);
                            },

                            listeners: [
                                {
                                    eventName: "EVENT_CLOSE",
                                    action: function () {

                                        BI.Popovers.remove(self.getName() + type);
                                    }
                                }
                            ]
                        };

                        BI.Popovers.create(self.getName() + type, {
                            type: "bi.popover",
                            header:  stepMap[step].name,
                            body: pane,
                        }).open(self.getName() + type);
                    }
                }]
            }
        },
        setOpened: function (v) {
            ExpanderNode.superclass.setOpened.apply(this, arguments);
            //this.checkbox.setSelected(v);
        }
    })
    BI.shortcut("dec.factory.widget.advance", advancePane);

})()