!(function () {


    var addPopup = BI.inherit(BI.Widget, {

        props: {

            btns: [BI.i18nText(BI.i18nText("Dec-Basic_Sure")), BI.i18nText(BI.i18nText("Dec-Basic_Cancel"))],
            onClickConfirm: BI.emptyFn,
            check:false,
            checkFn: BI.emptyFn,
            info: {},
            cardType: "bi.layout"
        },
        watch: {
            parameters: function () {
                this.paramSettingPane.populate(this.model.paramItems, this.model.paramHeader);
            },
            config: function(v) {
                this.editor.setValue(v)
            }
        },
        _store: function () {
            return BI.Models.getModel("dec.model.factory.sub.config.editor", this.options.info);
        },

        render: function () {
            var self = this, o = this.options;
            return {
                type: "bi.vertical",
                height:400,
                tgap:8,
                items: [{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Factory_Customize_Name") + ":",
                        title: BI.i18nText("Plugin-Factory_Customize_Name") + ":",
                        textAlign: "left",
                        width: 50
                    },,{
                        height: 24,
                        width: 330,
                        type: "bi.editor",
                        cls: "bi-border",
                        value:o.info.name,
                        ref: function (_ref) {
                            self.customizeName = _ref;
                        }
                    }]

                },{
                    type: "bi.vertical_adapt",
                    height: 24,
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        text: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        title: BI.i18nText("Plugin-Dec-Data_Set_Data_Type"),
                        textAlign: "left",
                        width: 50
                    }, {
                        type: "bi.text_value_check_combo",
                        width: 330,
                        items: o.info.items,
                        value: o.info.type,
                        listeners: [{
                            eventName: BI.TextValueCheckCombo.EVENT_CHANGE,
                            action: function () {
                                self.model.config = self.store._getConfig(this.getValue()[0], this.options.items)
                                //self.store.setFormatterType(this.getValue()[0]);
                                self.model.type = this.getValue()[0]
                            }
                        }],
                        ref: function (_ref) {
                            self.typeCombo = _ref;
                        }
                    }]
                },{
                    type: "bi.textarea_editor",
                    cls: "bi-border",
                    height:148,
                    value: o.info.config,
                    ref: function (_ref) {
                        self.editor = _ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function () {
                            self.model.config = this.getValue();
                        }
                    }]
                },{
                    type: "bi.vtape",
                    height: 160,
                    tgap: 10,
                    items: [{
                        type: "bi.left_right_vertical_adapt",
                        height: 24,
                        items: {
                            left: [{
                                type: "bi.label",
                                cls: "dec-font-weight-bold",
                                text: BI.i18nText("Dec-Basic_Parameter_Setting")
                            }],
                            right: [{
                                type: "bi.icon_button",
                                cls: "add-keyword-font",
                                level: "ignore",
                                lgap: 10,
                                handler: function () {
                                    self.store.addParamter({
                                        type:"String",
                                        name:"",
                                        value:""});
                                }
                            },{
                                type: "bi.icon_button",
                                cls: "refresh-font",
                                lgap: 10,
                                level: "ignore",
                                handler: function () {
                                    self.store.refreshParam()
                                }
                            }]
                        }
                    }, {
                        type: "bi.components.style_table",
                        cls: "param-table factory-param",
                        width: 500,
                        columnSize: [120, 140, 160,""],
                        items:self.model.paramItems,
                        header: self.model.paramHeader,
                        ref: function () {
                            self.paramSettingPane = this;
                        }
                    }]
                },]
            };
        },

        getValue: function () {
            return {
                name: this.typeCombo.getValue()[0],
                text: this.editor.getValue(),
                customizeName: this.customizeName.getValue(),
                parameters: this.model.parameters,
            }
        }
    });
    BI.shortcut("dec.factory.sub.config.editor", addPopup);


    var PanleModel = BI.inherit(Fix.Model, {
        _init: function () {
            this.service = BI.Services.getService("dec.service.data.set");
        },
        state: function () {
            return {
                parameters: this.options.parameters ? this.options.parameters : [],
                config:this.options.config,
                type:"",
              /*  paramHeader: function () {
                    //定义参数列表表头
                    var map = BI.map(BI.Constants.getConstant("dec.constants.data.set.sql.header"), function (i, v) {
                        return BI.extend({
                            textAlign: "left",
                            height: 30,
                            hgap: 10
                        }, v);
                    });
                    map.push({
                        textAlign: "left",
                        height: 30,
                        hgap: 10,
                        text: ""
                    });
                    return [map];
                }(),*/
            };
        },
        computed: {
            paramHeader: function () {
                //定义参数列表表头
                var map = BI.map(BI.Constants.getConstant("dec.constants.data.set.sql.header"), function (i, v) {
                    return BI.extend({
                        textAlign: "left",
                        height: 30,
                        hgap: 10
                    }, v);
                });
                map.push({
                    textAlign: "left",
                    height: 30,
                    hgap: 10,
                    text: ""
                });
                return [map];
            },
            paramItems: function () {
                var self = this;
                return BI.map(this.model.parameters, function (i, param) {
                    return [{
                        type: "bi.text_editor",
                        value: param.name,
                        textAlign: "left",
                        height: 30,
                        lgap: 10,
                        listeners: [{
                            eventName: BI.TextEditor.EVENT_CHANGE,
                            action: function () {
                                self.setParamName(i, this.getValue());
                            }
                        }]
                    }, {
                        type: "bi.icon_text_value_combo",
                        cls: "field-type-change",
                        height: 30,
                        items: BI.Constants.getConstant("dec.constants.data.set.sql.field"),
                        value: param.type,
                        listeners: [{
                            eventName: BI.IconTextValueCombo.EVENT_CHANGE,
                            action: function () {
                                self.setParamType(i, this.getValue()[0]);
                            }
                        }]
                    }, self.service.createParameterValueItem(param, function (val) {
                        self.setParamValue(i, val);
                    }), {
                        type: "bi.icon_button",
                        cls: "default-delete-font",
                        height: 30,
                        lgap: 10,
                        title: BI.i18nText("Dec-Basic_Delete"),
                        handler: function () {
                            self.deleteParameter(i);
                        }
                    }];
                });
            },
        },

        actions: {
            refreshParam: function (v) {
                var self = this;
                debugger
                Dec.Utils.getDataSetParameters({
                    datasetData:{
                        loaderConfig:self.model.config
                    },
                    datasetType:"factory",
                    datasetName:""
                }, function (res) {

                    self.model.parameters = self.service.getParameters(res.data, self.model.parameters);
                });
            },
            addParamter:function(v){
                this.model.parameters.push(v);
            },
            deleteParameter:function(index){
                this.model.parameters.splice(index, 1);
            },
            setParamName: function (index, name) {
                this.model.parameters[index].name = name;
            },
            setParamType: function (index, type) {
                if (this.model.parameters[index].type !== type) {
                    this.model.parameters[index].type = type;
                    this.model.parameters[index].value = this.service.getDefaultValueByType(type);
                    this.model.parameters.splice(0, 0);
                }
            },
            setParamValue: function (index, val) {
                this.model.parameters[index].value = val;
            },
            _getConfig:function(value, items){
                for (let i = 0; i < items.length; i++) {
                    if(value === items[i].value) {
                        return items[i].dftConfig;
                    }
                }
                return "{}"
            },
        }
    });
    BI.model("dec.model.factory.sub.config.editor", PanleModel);
}());